# Restic role

*Compatibility: Debian Buster*

## Configuration example
```
restic_credentials:
  envvars: |
      export OS_AUTH_URL=someurl
      export OS_REGION_NAME=someregion
      export OS_USERNAME=someusername
      export OS_PASSWORD=somepassword
      export OS_TENANT_NAME=sometenant
      export MYSQLPASSWORD=sometenant
  restic_password: 'somepassword'

restic:
  backups:
    - name: 'swift-matomo'
      repository: 'swift:restic_matomo-backup:/piwik.killiankemps.fr'
      cron:
        minute: '0'
        hour: '3'
      stdin:
        - database: 'mysqldump -u piwik -p$MYSQLPASSWORD 127.0.0.1'
          filename: 'production.sql'
    - name: 'local-mastodon'
      repository: '/srv/backups/restic_mastodon-backup'
      cron:
        minute: '0'
        hour: '2'
      folders:
        - '/home/mastodon/live/.env.production'
        - '/home/mastodon/live/public/system'
```
